#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;


template <typename T> using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

// vector<int> p, res;
// vector<pair<int, int>> lr;
// int leader(int a) {
//     return (p[a] == a)?a: p[a] = leader(p[a]);
// }
//
//
// int unite(int a, int b, int rs) {
//     a = leader(a), b = leader(b);
//     p[a] = b;
//     res[b] = rs;
//     lr[b] = {min(lr[a].first, lr[b].first), max(lr[a].second, lr[b].second)};
// }
int col = 0;

struct Node {
    int sum, mx, ind, mn, push = 0;

    Node(int sum, int mx, int ind, int mn): sum(sum), mx(mx), ind(ind), mn(mn) {}
    Node () {}
    void apply(int l, int r, int val) {
        sum = (r - l) * val;
        mx = val;
        mn = val;
        push = val;
    }
};

Node merge(Node l, Node r) {
    Node n;
    n.sum = l.sum + r.sum;
    if (l.mx > r.mx) n.ind = l.ind;
    else n.ind = r.ind;
    n.mx = max(l.mx, r.mx);
    n.mn = min(l.mn, r.mn);
    return n;
}

struct SegTree {
    int n;
    vector<Node> tree;

    SegTree(vector<int>& a) : n(a.size()) {
        tree.assign(4 * n, Node());
        build(0, 0, n, a);
    }

    void push(int v, int l, int r) {
        if (tree[v].push != 0) {
            int mid = (r + l) / 2;
            tree[2 * v + 1].apply(l, mid, tree[2 * v + 1].push);
            tree[2 * v + 2].apply(mid, r, tree[2 * v + 2].push);
            tree[v].push = 0;
        }
    }
    void build(int i, int l, int r, vector<int> &a) {
        if (l == r - 1) {
            tree[i] = {a[l], a[l], l, a[l]};
            return;
        }
        int mid = (l + r) / 2;
        build(i * 2 + 1, l, mid, a);
        build(i * 2 + 2, mid, r, a);
        tree[i] = merge(tree[i * 2 + 1], tree[i * 2 + 2]);
    }

    void update(int ql, int qr, int val, int v, int l, int r) {
        if (tree[v].mn > val) return;
        if (qr <= l || r <= ql) return;
        if (l >= ql && r <= qr && tree[v].mx <= val) {
            tree[v].apply(l, r, val);
            return;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        update(ql, qr, val, 2 * v + 1, l, m);
        update(ql, qr, val, 2 * v + 2, m, r);
        tree[v] = merge(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    Node query(int ql, int qr, int val, int v, int l, int r) {
        if (tree[v].mn > val) return {0, 0, 0, (int)1e9};
        if (qr <= l || r <= ql) return {0, 0, 0, (int) 1e9};
        if (l >= ql && r <= qr && tree[v].mx <= val) {col += val * (r - l) - tree[v].sum; return tree[v]; }
        push(v, l, r);
        int m = (l + r) / 2;
        return merge(query(ql, qr, val, 2 * v + 1, l, m), query(ql, qr, val,  2 * v + 2, m, r));
    }
    Node get(int ql, int qr, int v, int l, int r) {
        if (qr <= l || r <= ql) return {0, 0, 0, (int)1e9};
        if (l >= ql && r <= qr) {return tree[v];}
        push(v, l, r);
        int m = (l + r) / 2;
        return merge(get(ql, qr, 2 * v + 1, l, m), get(ql, qr, v * 2 + 2, m, r));
    }
};

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; i++) cin >> h[i];
    SegTree st(h);
    ordered_set<pair<pair<int, int>, int>> o;
    for (int i = 0; i < n; i++) o.insert({{i, i}, 0});
    for (int i = 0; i < n - 1; i++) {
        col = 0;
        int k;
        cin >> k;
        k--;
        pair<pair<int, int>, int> p1 = *o.find_by_order(k), p2 = *o.find_by_order(k + 1);
        int l1 = p1.first.first;
        int r1 = p1.first.second;
        int l2 = p2.first.first;
        int r2 = p2.first.second;
        int rs = p1.second + p2.second;

        auto [sum1, mx1, ind1, push1, mn1] = st.get(l1, r1 + 1, 0, 0, n);
        auto [sum2, mx2, ind2, push2, mn2] = st.get(l2, r2 + 1, 0, 0, n);

        if (ind1 + 1 < ind2) {
            Node a = st.query(ind1 + 1, ind2, min(mx1, mx2), 0,0,n);
            rs += col;
            st.update(ind1 + 1, ind2, min(mx1, mx2), 0, 0, n);
        }
        cout << rs << '\n';

        o.erase(o.find_by_order(k + 1));
        o.erase(o.find_by_order(k));
        o.insert({{l1, r2}, rs});
    }
}